Unit ast2e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTAFSI_p;

procedure ast2e(var A :Array of Extended; M :Integer; N :Integer;
                var B :Array of Extended; var IERR :Integer);

implementation

procedure ast2e(var A :Array of Extended; M :Integer; N :Integer;
                var B :Array of Extended; var IERR :Integer);
var
K,KB,KP1,NM1 :Integer;
T,X :Extended;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180;
begin
{ *********************************************************C }
{    PEEHE CCTEM A*X=B C TPEXAOHAHO MATPE A.  C }
{ *********************************************************C }

{   YCTAHOBEHE KOHTPO HA BOMOHOCT EPEOHEH }
X  := 0.0e0;
_10:

{   POBEPKA PABHOCT AAH APAMETPOB M  N }
if ( N  >=  1 ) and (  M  >=  1 ) 
 then goto _20;
IERR  := 65;
UTAFSI('A','S','T','2','E',IERR);
goto _180;
_20:
IERR  := 0;
A[0+0*M] := A[0+1*M];
NM1  := N - 1;
if ( NM1  <  1 ) 
 then goto _70;
A[0+1*M] := A[0+2*M];
A[0+2*M] := 0.0e0;
A[(N-1)+2*M] := 0.0e0;

{   PBEEHE MATP K TPEYOHOMY BY }
for K:=1 to NM1 do
 begin
  KP1  := K + 1;

{   EPECTAHOBKA,EC TPEYETC }
  if ( Abs(A[(KP1-1)+0*M]) <=  Abs(A[(K-1)+0*M]) ) 
   then goto _30;
  T  := A[(KP1-1)+0*M];
  A[(KP1-1)+0*M] := A[(K-1)+0*M];
  A[(K-1)+0*M] := T;
  T  := A[(KP1-1)+1*M];
  A[(KP1-1)+1*M] := A[(K-1)+1*M];
  A[(K-1)+1*M] := T;
  T  := A[(KP1-1)+2*M];
  A[(KP1-1)+2*M] := A[(K-1)+2*M];
  A[(K-1)+2*M] := T;
  T  := B[KP1-1];
  B[KP1-1] := B[K-1];
  B[K-1] := T;
_30:

{   AYCCOBO CKEHE }
  T  := 0.0e0;
  if ( A[(K-1)+0*M] <>  0.0e0 ) 
   then goto _40;
  IERR  := -K;
  goto _50;
_40:
  T  := -A[(KP1-1)+0*M]/A[(K-1)+0*M];
_50:
  A[(KP1-1)+0*M] := A[(KP1-1)+1*M] + T*A[(K-1)+1*M];
  A[(KP1-1)+1*M] := A[(KP1-1)+2*M] + T*A[(K-1)+2*M];
  A[(KP1-1)+2*M] := 0.0e0;
  B[KP1-1] := B[KP1-1] + T*B[K-1];
_60:
 end;
_70:

{   PEEHE CCTEM }
if ( A[(N-1)+0*M] <>  0.0e0 ) 
 then goto _90;
IERR  := -N;
if ( B[N-1] <>  0.0e0 ) 
 then goto _80;
B[N-1] := 1.0e0;
goto _100;
_80:
IERR  := 67;
UTAFSI('A','S','T','2','E',IERR);
goto _180;
_90:
B[N-1] := B[N-1]/A[(N-1)+0*M];
_100:
if ( IERR  <>  0 ) 
 then UTAFSI('A','S','T','2','E',IERR);
if ( N  =  1 ) 
 then goto _180;
T  := B[NM1-1] - A[(NM1-1)+1*M]*B[N-1];
if ( A[(NM1-1)+0*M] <>  0.0e0 ) 
 then goto _120;
if ( T  <>  0.0e0 ) 
 then goto _110;
B[NM1-1] := 1.0e0;
goto _130;
_110:
IERR  := 67;
UTAFSI('A','S','T','2','E',IERR);
goto _180;
_120:
B[NM1-1] := T/A[(NM1-1)+0*M];
_130:
KP1  := K - 2;
if ( KP1  <  1 ) 
 then goto _180;
for KB:=1 to KP1 do
 begin
  K  := KP1 - KB + 1;
  T  := B[K-1] - A[(K-1)+1*M]*B[K+0] - A[(K-1)+2*M]*B[K+1];
  if ( A[(K-1)+0*M] <>  0.0e0 ) 
   then goto _150;
  if ( T  <>  0.0e0 ) 
   then goto _140;
  B[K-1] := 1.0e0;
  goto _160;
_140:
  IERR  := 67;
  UTAFSI('A','S','T','2','E',IERR);
  goto _180;
_150:
  B[K-1] := T/A[(K-1)+0*M];
_160:
_170:
 end;
_180:
end;

end.
